# Chapter 12: Talking to Bitcoind

While working with Bitcoin Scripts, we hit the boundaries of what's possible with `bitcoin-cli`. Fortunately, there are other ways to work with the Bitcoin network. There are APIs that will ultimately allow you to access _all_ of Bitcoin's functionality, but we're going to start off with the simpler APIs that largely duplicate `bitcoin-cli` by accessing `bitcoind` through RPC. Consider it a new way to do what you already know and a gateway to the larger world of working with APIs.

## Objectives for This Chapter

After working through this chapter, a developer will be able to:

   * Decide Between Different Methods of Talking to Bitcoind
   * Create Bitcoin Transactions by Talking Directly to Bitcoind
   
Supporting objectives include the ability to:

   * Understand How to Use APIs
   * Understand How RPC and Curl Interact
   * Create a Foundation for Accessing Bitcoind 
   
## Table of Contents

  * [Section One: Accessing Bitcoind with Curl](12_1_Accessing_Bitcoind_with_Curl.md)
  * [Section Two: Accessing Bitcoind with C](12_2_Accessing_Bitcoind_with_C.md)
  * [Section Three: Accessing Bitcoind with Node](12_3_Accessing_Bitcoind_with_Node.md) 
